/*-----------------------------------------------------------------------
Nom du fichier:LibRobot.h
Auteur: Philippe MARIANO

Rle: fichier d'en-tte de la librairie ssi.lib 
Cr le 23/04/08
Dernire rvision le 23/04/08

Cross compilateur utilis: CodeVisionAVR
Composant cible : ATMEL 8 bits

Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SSI
Il doit tre plac dans le sous rpertoire \CVAVR\INC\ 
------------------------------------------------------------------------*/

#ifndef _LibRobot_INCLUDED_ // Evite que le fichier ne soit inclus plusieurs fois
#define _LibRobot_INCLUDED_


// -----------------------------------------------------
// Dfinition du code des BPs de la carte AT90S8535  SSI
//------------------------------------------------------
#ifndef S1 
#define S1		1    
#endif 
#ifndef S2 
#define S2		2   
#endif	
#ifndef S3 
#define S3		4
#endif
#ifndef S4 
#define S4		8  
#endif


// ********************************************************************************
//
// Prototype des fonctions gnrales de la carte SSI 
// 
// ********************************************************************************
// ----------------------- Rcapitulatif ----------------------------------------- 
// unsigned char Lire_BP_Robot(void);
// ******************************************************************************** 
#pragma used+

unsigned char Lire_BP_Robot(void);
/*
Rle : Lit l'tat des BP de la carte Robot acadmique(PortB et D) 

Commentaires : La fonction renvoie le code de la touche actionne lors du premier
appel (S1 = 1, S2 = 2, S3 = 4, S4 = 8)
puis 0x00 si la touche est maintenue ou 0xFF si la touche est relche. 

Entres : aucunes 

sortie : code de la touche ou 0x00 ou 0xFF
*/

#pragma used-

#pragma library LibRobot.lib

#endif    // termine la directive ifndef