;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "RBOTV3.vec"
	.INCLUDE "RBOTV3.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE robot suiveur de ligne 
;      10 Version : 3
;      11 Date    : 01/05/2008
;      12 Author  : Mariano philippe, Lorrain, Herveau, Peras                            
;      13 Company : Lyce Pierre Emile Martin
;      14 1, Avenue de Gionne 18000 BOURGES                                
;      15 Comments: Programme du robot """"""""Ramasseur"""""""
;      16 avec modification des paramtres PWM sur le robot
;      17 et test des servos
;      18 
;      19 Chip type           : ATmega8535
;      20 Program type        : Application
;      21 Clock frequency     : 8,000000 MHz
;      22 Memory model        : Small
;      23 External SRAM size  : 0
;      24 Data Stack size     : 128
;      25 *********************************************/
;      26 
;      27 //************************************************************************************************
;      28 // Librairies  
;      29 // --------------------------------------------------------------------------------------------- 
;      30 #include <mega8535.h> 
;      31 #include <delay.h>
;      32 #include <stdio.h>       
;      33 #include <stdlib.h>
;      34 #include <string.h>
;      35 #include <math.h>
;      36 #include <ssi.h>  		// Fonction d'affichage
;      37 #include "LibRobot.h" 		// Gestion clavier carte robot
;      38 //************************************************************************************************
;      39 
;      40 // Alphanumeric LCD Module functions   
;      41 #asm
;      42    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      43 #endasm

;      44 #include <lcd.h>
;      45 
;      46 //************************************************************************************************
;      47 // Dfinitions  divers
;      48 // ----------------------------------------------------------------------------------------------- 
;      49 #define ACO 	ACSR.5      // Sortie du comparateur analogique      
;      50 
;      51 // Caractres spcifiques  afficher sur le LCD  
;      52 // ----------------------------------------------------------------------------------------------- 
;      53 #define Caractere_FlecheH	0 
;      54 #define Caractere_FlecheB	1
;      55 
;      56 // Adresses de la CGRAM de l'afficheur LCD type Hitachi
;      57 // ----------------------------------------------------------------------------------------------- 
;      58 //@ : adresse 
;      59 #define Add_FlecheH_CGRAM 0x40 // @1 Caractre flche haut
;      60 #define Add_FlecheB_CGRAM 0x48 // @2 Caractre flche bas
;      61 
;      62 // Signaux de commande des capteurs IR 
;      63 // ----------------------------------------------------------------------------------------------- 
;      64 // PA7 | PA6 | PA5 | PA4  | PA3 | PA2 | PA1 | PA0
;      65 // D3  | D2  | D1  | IRG  |IRCG | IRC |IRCD | IRD
;      66 #define CAPTEUR_IR 	PORTA     // PORTA partag entre Del_IR et Dels Visu
;      67 
;      68 // Signaux de commande des moteurs 
;      69 // -----------------------------------------------------------------------------------------------  
;      70 #define CDE_MOTD	OCR1A       // Cde moteur Droit
;      71 #define CDE_MOTG	OCR1B	    // Cde moteur Gauche
;      72 
;      73 // Signaux de commande des Servos
;      74 // ----------------------------------------------------------------------------------------------- 
;      75 #define CDE_SERVO1	PORTB.0
;      76 #define CDE_SERVO2	PORTB.1
;      77 
;      78 // Dels affichage position robot par rapport  la ligne
;      79 // ----------------------------------------------------------------------------------------------- 
;      80 #define DELG    PORTB.4 	// Led D4 sur la carte Robot SI
;      81 #define DELCG   PORTA.7 	// Led D3   "	"	"
;      82 #define DELCD	PORTA.6 	// Led D2   "	"	"
;      83 #define DELD    PORTA.5 	// Led D1   "	"	"
;      84 
;      85 //Pour info: Rapports cycliques alpha du signal de commande des moteurs 
;      86 // ----------------------------------------------------------------------------------------------- 
;      87 // OCR1x = 255*alpha
;      88 // 		OCR1x		 alpha 
;      89 #define _0PC	 0		 // 0% 
;      90 #define _5PC	 13              // 5% 
;      91 #define _10PC	 25              // 10%
;      92 #define _15PC	 38              // 15%
;      93 #define _20PC    51		 // 20%
;      94 #define _25PC	 64              // 25%
;      95 #define _30PC    76		 // 30%
;      96 #define _35PC	 89              // 35% 
;      97 #define _40PC    102		 // 40%
;      98 #define _45PC	 115             // 45%
;      99 #define _50PC    128             // 50%
;     100 #define _55PC	 140             // 55% 
;     101 #define _60PC    153             // 60%
;     102 #define _65PC	 166             // 65%
;     103 #define _70PC    179             // 70%
;     104 #define _75PC	 191             // 75%
;     105 #define _80PC    205             // 80%     
;     106 #define _85PC    219             // 85% 
;     107 #define _90PC    233             // 90% 
;     108 // ----------------------------------------------------------------------------------------------*/
;     109 //***************************************************************************************************
;     110 
;     111 //***************************************************************************************************
;     112 // Constantes en eeprom
;     113 // -----------------------------------------------------------------------------------------------
;     114 // Table des valeurs de rglage PWM en eeprom  ( initialiser avec le fichier Robot2base.eep 
;     115 // lors de la premire mise en oeuvre
;     116 //*************************************************************************************************** 
;     117 //Organisation de la table		MG   MD	
;     118 eeprom unsigned char PWM_EEPROM[11][2];  	// Centre

	.ESEG
_PWM_EEPROM:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     119 				          	// Droite
;     120 				         	// Droite+
;     121 				    		// Droite2+
;     122 				    		// Droite3+
;     123 				    		// HorsLigneD
;     124 				    		// Gauche
;     125 				    		// Gauche+
;     126 				    		// Gauche2+
;     127 				    		// Gauche3+
;     128 				    		// HorsLigneG
;     129 //***************************************************************************************************
;     130 // Constantes en flash
;     131 // --------------------------------------------------------------------------------------------------
;     132 // Tables des caractres personnaliss  placer dans la mmoire CGRAM du LCD  
;     133 // --------------------------------------------------------------------------------------------------
;     134 const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM

	.CSEG
;     135 const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
;     136 // --------------------------------------------------------------------------------------------------
;     137 // Tableau de structures des menus "Rglage des paramtres PWM"  
;     138 // --------------------------------------------------------------------------------------------------
;     139 flash struct Affichage_reglages {
;     140 		char ligne0[14];
;     141 		char ligne1[14];  
;     142 		} Tab_Aff_Reg[11]= {{"Centre MG  =","Centre MD  ="},
;     143 				    {"Droite MG  =","Droite MD  ="},
;     144 				    {"Droite+ MG =","Droite+ MD ="},
;     145 				    {"Droite2+ MG=","Droite2+ MD="},
;     146 				    {"Droite3+ MG=","Droite3+ MD="},
;     147 				    {"HorLigD MG =","HorLigD MD ="},
;     148 				    {"Gauche MG  =","Gauche MD  ="},
;     149 				    {"Gauche+ MG =","Gauche+ MD ="},
;     150 				    {"Gauche2+ MG=","Gauche2+ MD="},
;     151 				    {"Gauche3+ MG=","Gauche3+ MD="},
;     152 				    {"HorLigG MG =","HorLigG MD ="}};
;     153 // --------------------------------------------------------------------------------------------------
;     154 // Table de transcodage %PWM --> OCR1x
;     155 //--------------------------------------------------------------------------------------------------
;     156 const unsigned char Table_Calcul_OCR1x[19][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
;     157 {35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
;     158 {90,233}}; 		
;     159 //***************************************************************************************************
;     160  
;     161 //************************************************************************************************
;     162 // Prototype des fonctions  
;     163 // ----------------------------------------------------------------------------------------------- 
;     164 void Arret_Moteurs(void);	// Dsactivation des moteurs
;     165 void Active_Timer(void);    	// Activation des moteurs
;     166 void Mode_Run(void);        	// Suivi de ligne etc... 
;     167 void Prise_Balle(void);		// Squence de prise de la balle
;     168 //************************************************************************************************
;     169 
;     170 //************************************************************************************************
;     171 // Declare your global variables here 
;     172 // ----------------------------------------------------------------------------------------------- 
;     173 // type		nom		Commentaires
;     174 //------------------------------------------------------------------------------------------------ 
;     175 // Etats du graphe des transitions
;     176 // -----------------------------------------------------------------------------------------------
;     177 enum TMenu {Menu_Reglages, Menu_Servo, Menu_Run, Reglage_PWM, Activation, Affiche_Reglages,Cde_Servo
;     178  	} Menu=Menu_Reglages,Menu_1=Menu_Run;// Etats du graphe tests         

	.DSEG
;     179 // -----------------------------------------------------------------------------------------------
;     180 // Commandes des moteurs
;     181 // -----------------------------------------------------------------------------------------------
;     182 enum Etat_Commande_Moteur {DEPART,CDE_CENTRE, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, 
;     183 CDE_DROITE_2PLUS, CDE_DROITE_3PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS,CDE_GAUCHE_2PLUS,CDE_GAUCHE_3PLUS,
;     184 CDE_HORS_LIGNE_GAUCHE, CDE_HORS_LIGNE_DROITE } EtatCdeMot = DEPART;
;     185 // -----------------------------------------------------------------------------------------------
;     186 // Positions du robot par rapport  la ligne 
;     187 // -----------------------------------------------------------------------------------------------
;     188 enum Etat_Position_Robot {HORS_LIGNE, GAUCHE_3PLUS, GAUCHE_2PLUS = 3, CENTRE_1, GAUCHE_PLUS=7, 
;     189 CENTRE_3=14, GAUCHE, DROITE_3PLUS, DROITE_2PLUS=24, DROITE_PLUS=28, DROITE = 30,CENTRE_5} 
;     190 Position_Robot = HORS_LIGNE; 
;     191 //***************************************************************************************************
;     192 // Dtection de la cible => INT0 
;     193 // -----------------------------------------------------------------------------------------------
;     194 bit Cible=0;
;     195 
;     196 //***************************************************************************************************
;     197 // SP dtection cible 
;     198 // -----------------------------------------------------------------------------------------------
;     199 // External Interrupt 0 service routine
;     200 interrupt [EXT_INT0] void ext_int0_isr(void)
;     201 {

	.CSEG
_ext_int0_isr:
	RCALL __SAVEISR
;     202 // Dsactivation de l'INT0
;     203 GICR=0x00; // Dsactivation INT0 (bit6 de GICR)
	CLR  R30
	OUT  0x3B,R30
;     204 Arret_Moteurs();  // Arrt du robot
	RCALL _Arret_Moteurs
;     205 Cible = 1;
	SET
	BLD  R2,0
;     206 }  
	RCALL __LOADISR
	RETI
;     207 
;     208 //***************************************************************************************************
;     209 // Programme principal
;     210 //***************************************************************************************************
;     211 void main(void)
;     212 { // Dbut du main
_main:
;     213 //------------------------------------------------------------------------------------------------
;     214 // Declare your local variables here
;     215 // type		nom				Commentaires
;     216 //------------------------------------------------------------------------------------------------
;     217 unsigned char BP;			// Etat des boutons-poussoir 
;     218 unsigned char i;                        // Compteur d'usage gnral
;     219 unsigned char rcycl, rcycl_1;           // Saisie du rapport cyclique lors d'une modification manuelle
;     220 unsigned char NumServo=1, NumServo_1=1;	// Saisie du numro du servo
;     221 unsigned char decompte=5, decompte_1=5;	// Temporisation avant le passage en mode RUN
;     222 char i_n=0, i_n_1=1; 			// Compteurs: position dans le tableau des structures 
;     223 					// d'affichage
;     224 char display_buffer_ligne0[17]; 	// Tampon ligne 0 de l'afficheur LCD
;     225 char display_buffer_ligne1[17]; 	// Tampon ligne 1 de l'afficheur LCD
;     226 char pourcentage0[2], pourcentage1[2];  // Affichage pourcentage
;     227 //------------------------------------------------------------------------------------------------
;     228 
;     229 //------------------------------------------------------------------------------------------------
;     230 // Initialisation des priphriques
;     231 //------------------------------------------------------------------------------------------------                                        
;     232 // Input/Output Ports initialization
;     233 // Port A initialization
;     234 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     235 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;     236 		// Gestion des E_IR et des DEls (sauf D4)
;     237 PORTA=0xFF; 	// Dsactivation des EIR et des Dels  la mise sous tension
	SBIW R28,42
	LDI  R24,4
	LDI  R26,LOW(38)
	LDI  R27,HIGH(38)
	LDI  R30,LOW(_0x82*2)
	LDI  R31,HIGH(_0x82*2)
	RCALL __INITLOCB
;	BP -> R16
;	i -> R17
;	rcycl -> R18
;	rcycl_1 -> R19
;	NumServo -> R20
;	NumServo_1 -> R21
;	decompte -> Y+41
;	decompte_1 -> Y+40
;	i_n -> Y+39
;	i_n_1 -> Y+38
;	display_buffer_ligne0 -> Y+21
;	display_buffer_ligne1 -> Y+4
;	pourcentage0 -> Y+2
;	pourcentage1 -> Y+0
	LDI  R20,1
	LDI  R21,1
	RCALL SUBOPT_0x0
;     238 DDRA=0xFF;	// Port en sortie
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     239 
;     240 // Port B initialization
;     241 // Func0=Out Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     242 // State0=1 State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     243 		// Gestion des BP (sauf S4), D4, signal RIR, seuil capteur
;     244 PORTB=0x10;     // Del4 reli  PB4 (dsactive  la mise sous tension)
	LDI  R30,LOW(16)
	OUT  0x18,R30
;     245 DDRB=0x13;      // CDE_SERVO1 = 0 et CDE_SERVO2= 0 => position repos
	LDI  R30,LOW(19)
	OUT  0x17,R30
;     246 
;     247 // Port C initialization
;     248 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     249 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     250             // Gestion de l'afficheur LCD
;     251 PORTC=0x00; // Gre l'affichage, initialis par la fonction lcd_init(16);
	CLR  R30
	OUT  0x15,R30
;     252 DDRC=0x00;    
	OUT  0x14,R30
;     253 
;     254 // Port D initialization
;     255 // Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=Out Func7=In
;     256 // State0=T State1=T State2=T State3=0 State4=T State5=T State6=0 State7=T
;     257 		// Capteur magntique, moteurs, S4 et liaison srie
;     258 PORTD=0x04;     // Capteur magntique reli au 0V sur PD2
	LDI  R30,LOW(4)
	OUT  0x12,R30
;     259 DDRD=0x30; 	// Broches PWM moteurs droit et gauche en sortie, initialise  0
	LDI  R30,LOW(48)
	OUT  0x11,R30
;     260 
;     261 // Timer/Counter 1 initialization
;     262 // Clock source: System Clock
;     263 // Clock value: 8000,000 kHz
;     264 // Mode: Fast PWM top=00FFh
;     265 // OC1A output: Non-Inv.
;     266 // OC1B output: Non-Inv.
;     267 // Noise Canceler: Off
;     268 // Input Capture on Falling Edge
;     269 TCCR1A=0xA1;
	RCALL SUBOPT_0x1
;     270 TCCR1B=0x09;
;     271 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     272 TCNT1L=0x00;
	OUT  0x2C,R30
;     273 OCR1AH=0x00;
	OUT  0x2B,R30
;     274 OCR1AL=0x00;
	OUT  0x2A,R30
;     275 OCR1BH=0x00;
	OUT  0x29,R30
;     276 OCR1BL=0x00;
	OUT  0x28,R30
;     277 
;     278 // External Interrupt(s) initialization
;     279 // INT0: On
;     280 // INT0 Mode: Falling Edge
;     281 // INT1: Off
;     282 // INT2: Off
;     283 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     284 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
;     285 MCUCSR=0x00;
	CLR  R30
	OUT  0x34,R30
;     286 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     287 
;     288 // Analog Comparator initialization
;     289 // Analog Comparator: On
;     290 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     291 // Analog Comparator Output: Off
;     292 ACSR=0x00;
	CLR  R30
	OUT  0x8,R30
;     293 SFIOR=0x00;
	OUT  0x30,R30
;     294 
;     295 // LCD module initialization
;     296 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     297 
;     298 // Chargement initial de la mmoire CGRAM de l'afficheur avec deux 
;     299 // caractres personaliss 
;     300 for (i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x84:
	CPI  R17,8
	BRSH _0x85
;     301 {
;     302 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); // @1 Caractre flche haut
	MOV  R30,R17
	SUBI R30,-LOW(64)
	ST   -Y,R30
	LDI  R26,LOW(_flecheHaut*2)
	LDI  R27,HIGH(_flecheHaut*2)
	RCALL SUBOPT_0x2
	LPM  R30,Z
	RCALL SUBOPT_0x3
;     303 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); // @2 Caractre flche bas
	MOV  R30,R17
	SUBI R30,-LOW(72)
	ST   -Y,R30
	LDI  R26,LOW(_flecheBas*2)
	LDI  R27,HIGH(_flecheBas*2)
	RCALL SUBOPT_0x2
	LPM  R30,Z
	RCALL SUBOPT_0x3
;     304 }
	SUBI R17,-1
	RJMP _0x84
_0x85:
;     305 
;     306 //Initialisation de la position des Servos
;     307 CDE_SERVO1 = 0;
	CBI  0x18,0
;     308 CDE_SERVO2 = 0;
	CBI  0x18,1
;     309 
;     310 //------------------------------------------------------------------------------------------------
;     311  
;     312 // ------------------------------------Message d'accueil-------------------------------------------
;     313 lcd_clear();
	RCALL _lcd_clear
;     314 sprintf(display_buffer_ligne0,"******RBOT******");
	RCALL SUBOPT_0x4
	__POINTW1FN _129,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     315 sprintf(display_buffer_ligne1,"---PEM BOURGES--");
	RCALL SUBOPT_0x6
	__POINTW1FN _129,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     316 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     317 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x8
;     318 //------------------------------------------------------------------------------------------------
;     319 while (1)
_0x86:
;     320 {    
;     321    BP = Lire_BP_Robot();
	RCALL _Lire_BP_Robot
	MOV  R16,R30
;     322    
;     323    switch (Menu)
	__GETW1R 4,5
;     324    {// Dbut du switch principal
;     325       
;     326 // -------------------------------------Dbut Menus droulants-------------------------------------
;     327       case Menu_Reglages : if (Menu_1 != Menu)
	SBIW R30,0
	BRNE _0x8C
	__CPWRR 4,5,6,7
	BREQ _0x8D
;     328                        {
;     329                         sprintf(display_buffer_ligne0," Menu Reglages ");
	RCALL SUBOPT_0x4
	__POINTW1FN _129,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     330                     	sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
	RCALL SUBOPT_0x6
	__POINTW1FN _129,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     331                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     332                     	lcd_gotoxy(11,1);	// Affichage flecheHaut
	RCALL SUBOPT_0x9
;     333 			lcd_putchar(Caractere_FlecheH);	
;     334 			lcd_gotoxy(10,1);	// Affichage flecheBas
;     335 			lcd_putchar(Caractere_FlecheB);
;     336                        }
;     337                       
;     338                          switch(BP)
_0x8D:
	RCALL SUBOPT_0xA
;     339                          {                                  
;     340                       	   case S4: Menu = Affiche_Reglages;  break; // touche Enter
	BRNE _0x91
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 4,5
	RJMP _0x90
;     341                       	   case S2: Menu = Menu_Run;  break; // touche flche haut
_0x91:
	CPI  R30,LOW(0x2)
	BRNE _0x92
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 4,5
	RJMP _0x90
;     342                       	   case S1: Menu = Menu_Servo;  break; // touche flche bas
_0x92:
	CPI  R30,LOW(0x1)
	BRNE _0x94
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 4,5
	RJMP _0x90
;     343                       	   default: Menu = Menu_Reglages;
_0x94:
	CLR  R4
	CLR  R5
;     344                       	 }
_0x90:
;     345                        
;     346        		         Menu_1 = Menu_Reglages;
	CLR  R6
	CLR  R7
;     347        break;  
	RJMP _0x8B
;     348        
;     349        case Menu_Servo : if (Menu_1 != Menu)
_0x8C:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x95
	__CPWRR 4,5,6,7
	BREQ _0x96
;     350                        {
;     351                         sprintf(display_buffer_ligne0,"--Test Servos?--");
	RCALL SUBOPT_0x4
	__POINTW1FN _129,67
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     352                     	sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
	RCALL SUBOPT_0x6
	__POINTW1FN _129,84
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     353                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     354                     	lcd_gotoxy(11,1);	// Affichage flecheHaut
	RCALL SUBOPT_0x9
;     355 			lcd_putchar(Caractere_FlecheH);	
;     356 			lcd_gotoxy(10,1);	// Affichage flecheBas
;     357 			lcd_putchar(Caractere_FlecheB);
;     358                        }
;     359                       
;     360                          switch(BP)
_0x96:
	RCALL SUBOPT_0xA
;     361                          {                                  
;     362                       	   case S4: Menu = Cde_Servo;  break; // touche Enter
	BRNE _0x9A
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x215
;     363                       	   case S2: Menu = Menu_Reglages;  break; // touche flche haut
_0x9A:
	CPI  R30,LOW(0x2)
	BRNE _0x9B
	CLR  R4
	CLR  R5
	RJMP _0x99
;     364                       	   case S1: Menu = Menu_Run;  break; // touche flche bas
_0x9B:
	CPI  R30,LOW(0x1)
	BRNE _0x9D
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x215
;     365                       	   default: Menu = Menu_Servo;
_0x9D:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x215:
	__PUTW1R 4,5
;     366                       	 }
_0x99:
;     367                        
;     368        		         Menu_1 = Menu_Servo;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 6,7
;     369        break; 
	RJMP _0x8B
;     370        case Menu_Run : if (Menu_1 != Menu)
_0x95:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x9E
	__CPWRR 4,5,6,7
	BREQ _0x9F
;     371                        {
;     372                         sprintf(display_buffer_ligne0,"Activer robot ? ");
	RCALL SUBOPT_0x4
	__POINTW1FN _129,101
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     373                     	sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
	RCALL SUBOPT_0x6
	__POINTW1FN _129,118
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     374                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     375                     	lcd_gotoxy(11,1);	// Affichage flecheHaut
	RCALL SUBOPT_0x9
;     376 			lcd_putchar(Caractere_FlecheH);	
;     377 			lcd_gotoxy(10,1);	// Affichage flecheBas
;     378 			lcd_putchar(Caractere_FlecheB);
;     379                        }
;     380                       
;     381                         switch(BP)
_0x9F:
	RCALL SUBOPT_0xA
;     382                          {                                  
;     383                       	   case S4: Menu = Activation; break; // touche Enter
	BRNE _0xA3
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x216
;     384                       	   case S2: Menu = Menu_Servo; break; // touche flche haut
_0xA3:
	CPI  R30,LOW(0x2)
	BRNE _0xA4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x216
;     385                       	   case S1: Menu = Menu_Reglages; break; // touche flche bas
_0xA4:
	CPI  R30,LOW(0x1)
	BRNE _0xA6
	CLR  R4
	CLR  R5
	RJMP _0xA2
;     386                       	   default: Menu = Menu_Run;
_0xA6:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
_0x216:
	__PUTW1R 4,5
;     387                       	 }
_0xA2:
;     388                        
;     389        		        Menu_1 = Menu_Run;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 6,7
;     390        break;   
	RJMP _0x8B
;     391        
;     392        case Affiche_Reglages : if ((Menu_1 != Menu) || (i_n_1 != i_n))
_0x9E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA7
	__CPWRR 4,5,6,7
	BRNE _0xA9
	LDD  R30,Y+39
	LDD  R26,Y+38
	CP   R30,R26
	BRNE _0xA9
	RJMP _0xA8
_0xA9:
;     393                        {
;     394                         if (fmod(i_n,2)==0){ // si i_n pair
	RCALL SUBOPT_0xB
	BRNE _0xAB
;     395                         	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
	RCALL SUBOPT_0x5
;     396                         	itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
;     397                         	strcat(display_buffer_ligne0,pourcentage0);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x14
;     398                        		sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1);
	RCALL SUBOPT_0xC
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
	RCALL SUBOPT_0x5
;     399                        		itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x15
	RJMP _0x217
;     400                        	        strcat(display_buffer_ligne1,pourcentage1);
;     401                        		}
;     402                        		else { // si i_n impair
_0xAB:
;     403                         	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
	RCALL SUBOPT_0x5
;     404                         	itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x15
	RCALL __EEPROMRDB
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
;     405                                 strcat(display_buffer_ligne0,pourcentage0);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x14
;     406                        		sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2+1].ligne0);
	LDD  R30,Y+41
	RCALL SUBOPT_0x16
	CLR  R31
	RCALL SUBOPT_0xD
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
	RCALL SUBOPT_0x5
;     407                        		itoa(PWM_EEPROM[i_n/2+1][0],pourcentage1);
	LDD  R30,Y+39
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	ADD  R26,R30
	ADC  R27,R31
_0x217:
	RCALL __EEPROMRDB
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x18
	RCALL _itoa
;     408                        	 	strcat(display_buffer_ligne1,pourcentage1);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x18
	RCALL _strcat
;     409                        		}
;     410                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     411                     	lcd_gotoxy(14,0);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     412                     	lcd_putchar('%');
	RCALL SUBOPT_0x1B
;     413                     	lcd_gotoxy(15,0);	// Affichage flecheHaut
	RCALL SUBOPT_0x1A
;     414 			lcd_putchar(Caractere_FlecheH);
	RCALL SUBOPT_0x1C
	RCALL _lcd_putchar
;     415 			lcd_gotoxy(14,1);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1D
;     416                     	lcd_putchar('%');	
	RCALL SUBOPT_0x1B
;     417 			lcd_gotoxy(15,1);	// Affichage flecheBas
	RCALL SUBOPT_0x1D
;     418 			lcd_putchar(Caractere_FlecheB);
	RCALL SUBOPT_0x1E
	RCALL _lcd_putchar
;     419 			i_n_1 = i_n;
	LDD  R30,Y+39
	STD  Y+38,R30
;     420                        }
;     421                       
;     422                          switch(BP)
_0xA8:
	RCALL SUBOPT_0xA
;     423                          {                                  
;     424                       	   case S4:  if (fmod(i_n,2)==0) // si i_n pair
	BRNE _0xB0
	RCALL SUBOPT_0xB
	BRNE _0xB1
;     425                       	                 rcycl = PWM_EEPROM[i_n/2][0];
	RCALL SUBOPT_0x10
	ADD  R26,R30
	ADC  R27,R31
	RJMP _0x218
;     426                       	   	     else     
_0xB1:
;     427                       	   	         rcycl = PWM_EEPROM[i_n/2][1];
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x15
_0x218:
	RCALL __EEPROMRDB
	MOV  R18,R30
;     428                       	   	         
;     429                       	             Menu = Reglage_PWM;  
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x219
;     430                       	   break;  
;     431                       	   case S3: Menu = Menu_Reglages; break;
_0xB0:
	CPI  R30,LOW(0x4)
	BRNE _0xB3
	CLR  R4
	CLR  R5
	RJMP _0xAF
;     432                       	   case S1: if (i_n < 20) i_n++; else i_n=0; break; 
_0xB3:
	CPI  R30,LOW(0x1)
	BRNE _0xB4
	LDD  R26,Y+39
	CPI  R26,LOW(0x14)
	BRSH _0xB5
	LDD  R30,Y+39
	SUBI R30,-LOW(1)
	RJMP _0x21A
_0xB5:
	CLR  R30
_0x21A:
	STD  Y+39,R30
	RJMP _0xAF
;     433                       	   case S2: if (i_n > 0) i_n--; else i_n=20; break; 
_0xB4:
	CPI  R30,LOW(0x2)
	BRNE _0xBA
	LDD  R26,Y+39
	CLR  R30
	CP   R30,R26
	BRSH _0xB8
	LDD  R30,Y+39
	SUBI R30,LOW(1)
	RJMP _0x21B
_0xB8:
	LDI  R30,LOW(20)
_0x21B:
	STD  Y+39,R30
	RJMP _0xAF
;     434                       	   default: Menu = Affiche_Reglages;
_0xBA:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
_0x219:
	__PUTW1R 4,5
;     435                       	 }
_0xAF:
;     436                        
;     437        		       Menu_1 = Affiche_Reglages;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 6,7
;     438        break;   
	RJMP _0x8B
;     439          
;     440        case Reglage_PWM : if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
_0xA7:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xBB
	__CPWRR 4,5,6,7
	BRNE _0xBD
	CP   R18,R19
	BREQ _0xBC
_0xBD:
;     441                        { 
;     442                         if (fmod(i_n,2)==0){ // si i_n pair
	RCALL SUBOPT_0xB
	BRNE _0xBF
;     443                         	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
	RJMP _0x21C
;     444                         	itoa(rcycl,pourcentage0);
;     445                         	strcat(display_buffer_ligne0,pourcentage0);}
;     446                         	else{
_0xBF:
;     447                         	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xE
	POP  R26
	POP  R27
	RCALL SUBOPT_0xF
	LDI  R24,0
_0x21C:
	RCALL _sprintf
	ADIW R28,4
;     448                         	itoa(rcycl,pourcentage0);
	MOV  R30,R18
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
;     449                                 strcat(display_buffer_ligne0,pourcentage0);}
	RCALL SUBOPT_0x6
	RCALL _strcat
;     450                     	sprintf(display_buffer_ligne1,"Etr>Memo ECH>Q ");
	RCALL SUBOPT_0x6
	__POINTW1FN _129,135
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     451                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     452                     	lcd_gotoxy(15,0);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1A
;     453 			lcd_putchar('+');
	LDI  R30,LOW(43)
	RCALL SUBOPT_0x20
;     454 			lcd_gotoxy(15,1);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1D
;     455 			lcd_putchar('-');
	LDI  R30,LOW(45)
	RCALL SUBOPT_0x20
;     456 			rcycl_1 = rcycl;
	MOV  R19,R18
;     457                        }
;     458                       
;     459                          switch(BP)
_0xBC:
	RCALL SUBOPT_0xA
;     460                          {
;     461                            case S4: if (fmod(i_n,2)==0) // si i_n pair
	BRNE _0xC4
	RCALL SUBOPT_0xB
	BRNE _0xC5
;     462                       	                  PWM_EEPROM[i_n/2][0]=rcycl;
	RCALL SUBOPT_0x10
	ADD  R26,R30
	ADC  R27,R31
	RJMP _0x21D
;     463                       	   	     else     
_0xC5:
;     464                       	   	          PWM_EEPROM[i_n/2][1]=rcycl; 
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x21
	MOVW R26,R30
_0x21D:
	MOV  R30,R18
	RCALL __EEPROMWRB
;     465                       	   	     Menu = Affiche_Reglages;     
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x21E
;     466                       	   break;                                  
;     467                       	   case S3: Menu = Affiche_Reglages;  break; // touche Enter
_0xC4:
	CPI  R30,LOW(0x4)
	BRNE _0xC7
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x21E
;     468                       	   case S2: if (rcycl < 95) rcycl = rcycl+5; else rcycl = 95; break; 
_0xC7:
	CPI  R30,LOW(0x2)
	BRNE _0xC8
	CPI  R18,95
	BRSH _0xC9
	SUBI R18,-LOW(5)
	RJMP _0xCA
_0xC9:
	LDI  R18,LOW(95)
_0xCA:
	RJMP _0xC3
;     469                       	   case S1: if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; 
_0xC8:
	CPI  R30,LOW(0x1)
	BRNE _0xCE
	LDI  R30,LOW(5)
	CP   R30,R18
	BRSH _0xCC
	SUBI R18,LOW(5)
	RJMP _0xCD
_0xCC:
	LDI  R18,LOW(0)
_0xCD:
	RJMP _0xC3
;     470                       	   default: Menu = Reglage_PWM;
_0xCE:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
_0x21E:
	__PUTW1R 4,5
;     471                       	 }
_0xC3:
;     472                        
;     473        		       Menu_1 = Reglage_PWM;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1R 6,7
;     474        break;   
	RJMP _0x8B
;     475        
;     476        case Activation : if ((Menu_1 != Menu) || (decompte != decompte_1))
_0xBB:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xCF
	__CPWRR 4,5,6,7
	BRNE _0xD1
	LDD  R30,Y+40
	LDD  R26,Y+41
	CP   R30,R26
	BREQ _0xD0
_0xD1:
;     477                        {
;     478                         sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
	RCALL SUBOPT_0x4
	__POINTW1FN _129,151
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+45
	RCALL SUBOPT_0x22
	LDI  R24,4
	RCALL SUBOPT_0x23
;     479                     	sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
	__POINTW1FN _129,168
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     480                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     481                     	decompte_1 = decompte;
	LDD  R30,Y+41
	STD  Y+40,R30
;     482                        }
;     483                        
;     484                      if (BP==S3) {
_0xD0:
	CPI  R16,4
	BRNE _0xD3
;     485                                    decompte=8;
	LDI  R30,LOW(8)
	STD  Y+41,R30
;     486                                    Menu=Menu_Reglages;
	CLR  R4
	CLR  R5
;     487                                    break;
	RJMP _0x8B
;     488                      		 }
;     489                        		  else if(decompte == 0) 
_0xD3:
	LDD  R30,Y+41
	CPI  R30,0
	BRNE _0xD5
;     490                      		       		Mode_Run();
	RCALL _Mode_Run
;     491                      delay_ms(1000); decompte--;
_0xD5:
	RCALL SUBOPT_0x24
	LDD  R30,Y+41
	SUBI R30,LOW(1)
	STD  Y+41,R30
;     492                      Menu_1 = Activation;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 6,7
;     493       break; 
	RJMP _0x8B
;     494       
;     495       case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1))
_0xCF:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x8B
	__CPWRR 4,5,6,7
	BRNE _0xD8
	CP   R21,R20
	BREQ _0xD7
_0xD8:
;     496                        {
;     497                         sprintf(display_buffer_ligne0,"Commande Servo%-u ",NumServo);
	RCALL SUBOPT_0x4
	__POINTW1FN _129,185
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R20
	RCALL SUBOPT_0x22
	LDI  R24,4
	RCALL SUBOPT_0x23
;     498                     	sprintf(display_buffer_ligne1,"[Etr]>Ch [Ech]>Q");
	__POINTW1FN _129,204
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x5
;     499                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     500                     	NumServo_1 = NumServo;
	MOV  R21,R20
;     501                        }
;     502                        
;     503                      switch(BP)
_0xD7:
	RCALL SUBOPT_0xA
;     504                          {                                  
;     505                       	   case S4: if (NumServo==2) NumServo=1;
	BRNE _0xDD
	CPI  R20,2
	BRNE _0xDE
	LDI  R20,LOW(1)
;     506                       	   		else if (NumServo==1) NumServo=2;		
	RJMP _0xDF
_0xDE:
	CPI  R20,1
	BRNE _0xE0
	LDI  R20,LOW(2)
;     507                       	   break;  
_0xE0:
_0xDF:
	RJMP _0xDC
;     508                       	   case S3: Menu = Menu_Servo; break;
_0xDD:
	CPI  R30,LOW(0x4)
	BRNE _0xE1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x21F
;     509                       	   case S2: if (NumServo==1) {CDE_SERVO1=1; DELD = 0;}
_0xE1:
	CPI  R30,LOW(0x2)
	BRNE _0xE2
	CPI  R20,1
	BRNE _0xE3
	SBI  0x18,0
	CBI  0x1B,5
;     510                       	   		else if  (NumServo==2) {CDE_SERVO2=1; DELCD = 0;}   
	RJMP _0xE4
_0xE3:
	CPI  R20,2
	BRNE _0xE5
	SBI  0x18,1
	CBI  0x1B,6
;     511                       	   break;
_0xE5:
_0xE4:
	RJMP _0xDC
;     512                       	   case S1: if (NumServo==1) {CDE_SERVO1=0;DELD = 1;}
_0xE2:
	CPI  R30,LOW(0x1)
	BRNE _0xEA
	CPI  R20,1
	BRNE _0xE7
	CBI  0x18,0
	SBI  0x1B,5
;     513                       	   		else if  (NumServo==2) {CDE_SERVO2=0; DELCD = 1;}
	RJMP _0xE8
_0xE7:
	CPI  R20,2
	BRNE _0xE9
	CBI  0x18,1
	SBI  0x1B,6
;     514                       	   break; 
_0xE9:
_0xE8:
	RJMP _0xDC
;     515                       	   default: Menu = Cde_Servo;
_0xEA:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
_0x21F:
	__PUTW1R 4,5
;     516                       	 }
_0xDC:
;     517                      Menu_1 = Cde_Servo;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 6,7
;     518       break;           
;     519  // -------------------------------------Fin Menus droulants------------------------------------------------       
;     520   } // Fin du switch principal
_0x8B:
;     521  } // Fin du while(1)
	RJMP _0x86
;     522 } // fin du main     
	ADIW R28,42
_0xEB:
	RJMP _0xEB
;     523 
;     524 
;     525 //***************************************************************************************************
;     526 // ************************************ Sous-programmes ********************************************
;     527 //***************************************************************************************************
;     528 // 	Mode_Run() 
;     529 //***************************************************************************************************
;     530 // Attention : on sort du menu Mode_Run par une coupure d'alimentation
;     531 //***************************************************************************************************
;     532 void Mode_Run()
;     533 {
_Mode_Run:
;     534 // ----------------------------------------------------------------------------------------------- 
;     535 // Variables locale  Mode_Run()
;     536 // type		nom		Commentaires
;     537 // ----------------------------------------------------------------------------------------------- 
;     538 unsigned char i,j,k;            // Compteurs de boucle  
;     539 unsigned char PWM[11][2];	// Table charge avec les coefficients
;     540 				// PWM de rglage des moteurs
;     541     				// issus de la table PWMEEPROM
;     542 unsigned char Cde_Del_IR;	// Permet de multiplexer la commande des dels IR
;     543 unsigned int Phase_Arret = 50;	// Compteur de boucle : Autorise la mesure de la position du robot
;     544 				// pendant 200ms aprs l'arrt des moteurs devant la cible 
;     545 // ----------------------------------------------------------------------------------------------- 
;     546 // -----------------------------------------------------------------------------------------------                                       
;     547 // Initialisation du mode Run: Chargement de PWM[][] alec les paramtres en EEPROM
;     548 // i,k: compteur ligne, j compteur colonne
;     549 for (i=0;i<11;i++)
	SBIW R28,22
	RCALL __SAVELOCR6
;	i -> R16
;	j -> R17
;	k -> R18
;	PWM -> Y+6
;	Cde_Del_IR -> R19
;	Phase_Arret -> R20,R21
	LDI  R20,50
	LDI  R21,0
	LDI  R16,LOW(0)
_0xEE:
	CPI  R16,11
	BRSH _0xEF
;     550  { 
;     551   for (j=0;j<2;j++)
	LDI  R17,LOW(0)
_0xF1:
	CPI  R17,2
	BRSH _0xF2
;     552    { 
;     553     for (k=0;k<19;k++)
	LDI  R18,LOW(0)
_0xF4:
	CPI  R18,19
	BRSH _0xF5
;     554      {
;     555        if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
	MOV  R30,R16
	RCALL SUBOPT_0x17
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	CLR  R31
	RCALL SUBOPT_0x11
	PUSH R30
	RCALL SUBOPT_0x25
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	POP  R26
	CP   R30,R26
	BRNE _0xF6
;     556          {   
;     557 	    PWM[i][j] = Table_Calcul_OCR1x[k][1];
	MOV  R30,R16
	CLR  R31
	MOVW R26,R28
	ADIW R26,6
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x2
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x21
	LPM  R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     558 	    break;
	RJMP _0xF5
;     559 	  }
;     560      }
_0xF6:
	SUBI R18,-1
	RJMP _0xF4
_0xF5:
;     561     }
	SUBI R17,-1
	RJMP _0xF1
_0xF2:
;     562   } 
	SUBI R16,-1
	RJMP _0xEE
_0xEF:
;     563   
;     564 // Global enable interrupts
;     565 #asm("sei") 
	sei
;     566 
;     567 // Fin initialisation
;     568 // ----------------------------------------------------------------------------------------------- 
;     569 
;     570 while (1)
_0xF7:
;     571     {// dbut Mode_Run() 
;     572 // ----------------------------------------------------------------------------------------------- 
;     573 // Phase d'arrt devant la cible: Mesure de la position et volution du graphe pendant 
;     574 // [4.3*10E-3*Phase_Arret] puis lancement du sous-programme Prise_Balle()
;     575 // ----------------------------------------------------------------------------------------------- 
;     576        if (Cible == 1) // Cible passe  1 lorsque le robot est devant la cible 
	SBRS R2,0
	RJMP _0xFA
;     577         {
;     578           if (Phase_Arret == 0)
	MOV  R0,R20
	OR   R0,R21
	BRNE _0xFB
;     579                 Prise_Balle(); // Cible <- dans INT0
	RCALL _Prise_Balle
;     580                 else 
	RJMP _0xFC
_0xFB:
;     581                   Phase_Arret--;
	__SUBWRN 20,21,1
_0xFC:
;     582         }
;     583 // -----------------------------------------------------------------------------------------------     
;     584 // Fonction acqurir
;     585 // -----------------------------------------------------------------------------------------------          
;     586       Position_Robot = HORS_LIGNE; // Initialisation  0	
_0xFA:
	CLR  R10
	CLR  R11
;     587       Cde_Del_IR = 1; 
	LDI  R19,LOW(1)
;     588  
;     589       for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
	LDI  R16,LOW(0)
_0xFE:
	CPI  R16,5
	BRSH _0xFF
;     590        {
;     591         CAPTEUR_IR = ~Cde_Del_IR;
	MOV  R30,R19
	COM  R30
	OUT  0x1B,R30
;     592       	delay_us(20);	// Activation d'un capteur  ajuster   (19s par dfaut)
	__DELAY_USB 53
;     593         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
	SBIS 0x8,5
	RJMP _0x100
	MOV  R30,R19
	__GETW2R 10,11
	CLR  R31
	OR   R30,R26
	OR   R31,R27
	__PUTW1R 10,11
;     594         CAPTEUR_IR = 0xFF; DELG = 1;
_0x100:
	RCALL SUBOPT_0x0
	SBI  0x18,4
;     595         Cde_Del_IR = Cde_Del_IR << 1 ;
	LSL  R19
;     596         delay_us(700);	//  ajuster   (540s par dfaut)
	__DELAY_USW 1400
;     597        } 
	SUBI R16,-1
	RJMP _0xFE
_0xFF:
;     598        			// Fin Acquisition de la position du robot par rapport  la ligne
;     599 // ----------------------------------------------------------------------------------------------- 
;     600 // Position_Robot  	Commentaires                                                         
;     601 // 	0		Hors_Ligne          
;     602 // 	1		Gauche3+            
;     603 // 	3 		Gauche2+
;     604 //	4		Centre1 (1 capteur IR sur la ligne) 	
;     605 // 	7		Gauche+ 
;     606 //	14		Centre3 (3 capteurs IR sur la ligne)
;     607 //	15		Gauche
;     608 //	16		Droite3+
;     609 //	24		Droite2+			
;     610 //	28		Droite+ 
;     611 //	30		Droite
;     612 // 	31 		Centre5 (5 capteurs IR sur la ligne)
;     613                  
;     614 // ----------------------------------------------------------------------------------------------- 
;     615 // Fonction Visualiser (Visualisation des capteurs sur la ligne)
;     616 // ----------------------------------------------------------------------------------------------- 
;     617 switch (Position_Robot)              
	__GETW1R 10,11
;     618        { 
;     619 // Position_Robot	Cde des Del
;     620 // -----------------------------------------------------------------------------------------------      
;     621        //        DLG  |   DLCG |   DLCD |   DLD 
;     622 // ----------------------------------------------------------------------------------------------- 
;     623 	case 0:  DELG=1; DELCG=1; DELCD=1; DELD=1; break;// Hors ligne
	SBIW R30,0
	BRNE _0x104
	SBI  0x18,4
	SBI  0x1B,7
	SBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     624  	case 1:  DELG=1; DELCG=1; DELCD=1; DELD=0; break;// Gauche3+
_0x104:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x105
	SBI  0x18,4
	SBI  0x1B,7
	SBI  0x1B,6
	CBI  0x1B,5
	RJMP _0x103
;     625   	case 3:  DELG=1; DELCG=1; DELCD=0; DELD=0; break;// Gauche2+
_0x105:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x106
	SBI  0x18,4
	SBI  0x1B,7
	CBI  0x1B,6
	CBI  0x1B,5
	RJMP _0x103
;     626    	case 4:  DELG=1; DELCG=1; DELCD=1; DELD=1; break;// Centre1 non visualis
_0x106:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x107
	SBI  0x18,4
	SBI  0x1B,7
	SBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     627         case 7:  DELG=1; DELCG=0; DELCD=0; DELD=0; break;// Gauche+  
_0x107:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x108
	SBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	CBI  0x1B,5
	RJMP _0x103
;     628         case 14: DELG=1; DELCG=0; DELCD=0; DELD=1; break;// Centre3 
_0x108:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x109
	SBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     629         case 15: DELG=1; DELCG=0; DELCD=0; DELD=0; break;// Gauche 
_0x109:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x10A
	SBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	CBI  0x1B,5
	RJMP _0x103
;     630         case 16: DELG=0; DELCG=1; DELCD=1; DELD=1; break;// Droite3+
_0x10A:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x10B
	CBI  0x18,4
	SBI  0x1B,7
	SBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     631         case 24: DELG=0; DELCG=0; DELCD=1; DELD=1; break;// Droite2+  
_0x10B:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x10C
	CBI  0x18,4
	CBI  0x1B,7
	SBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     632         case 28: DELG=0; DELCG=0; DELCD=0; DELD=1; break;// Droite+ 
_0x10C:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x10D
	CBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     633         case 30: DELG=0; DELCG=0; DELCD=0; DELD=1; break;// Droite 
_0x10D:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x10E
	CBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	SBI  0x1B,5
	RJMP _0x103
;     634         case 31: DELG=0; DELCG=0; DELCD=0; DELD=0; break;// Centre5
_0x10E:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x103
	CBI  0x18,4
	CBI  0x1B,7
	CBI  0x1B,6
	CBI  0x1B,5
;     635        }   
_0x103:
;     636 // ----------------------------------------------------------------------------------------------- 
;     637 // Fonction Traiter
;     638 // -----------------------------------------------------------------------------------------------      
;     639       switch (EtatCdeMot)              
	__GETW1R 8,9
;     640        { // Dbut switch (EtatCdeMot)                                 
;     641         case DEPART: Arret_Moteurs(); 
	SBIW R30,0
	BRNE _0x113
	RCALL _Arret_Moteurs
;     642         		if ((Position_Robot == CENTRE_3)||(Position_Robot == CENTRE_5))
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	CP   R30,R10
	CPC  R31,R11
	BREQ _0x115
	RCALL SUBOPT_0x26
	BRNE _0x114
_0x115:
;     643         		    { 
;     644         		      //delay_ms(5000);
;     645         		      Active_Timer();
	RCALL _Active_Timer
;     646         		      EtatCdeMot = CDE_CENTRE;
	RCALL SUBOPT_0x27
;     647         		    }
;     648         		    else  EtatCdeMot = DEPART;
	RJMP _0x117
_0x114:
	CLR  R8
	CLR  R9
_0x117:
;     649         break;   
	RJMP _0x112
;     650         
;     651         case CDE_CENTRE : CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
_0x113:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x118
	LDD  R30,Y+6
	RCALL SUBOPT_0x28
	LDD  R30,Y+7
	RCALL SUBOPT_0x29
;     652                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	RCALL SUBOPT_0x2A
	BRNE _0x119
	RCALL SUBOPT_0x2B
;     653                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x11A
_0x119:
	RCALL SUBOPT_0x2C
	BRNE _0x11B
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP _0x220
;     654                           		else EtatCdeMot = CDE_CENTRE;
_0x11B:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x220:
	__PUTW1R 8,9
_0x11A:
;     655         break;  
	RJMP _0x112
;     656         
;     657         
;     658         case CDE_DROITE:CDE_MOTG = PWM[1][0]; CDE_MOTD = PWM[1][1]; 
_0x118:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x11D
	LDD  R30,Y+8
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0x2D
;     659                          if (Position_Robot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
	RCALL SUBOPT_0x26
	BRNE _0x11E
	RCALL SUBOPT_0x27
;     660                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x11F
_0x11E:
	RCALL SUBOPT_0x2E
	BRNE _0x120
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x221
;     661                           		else EtatCdeMot = CDE_DROITE;
_0x120:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0x221:
	__PUTW1R 8,9
_0x11F:
;     662         break;   
	RJMP _0x112
;     663         
;     664         case CDE_DROITE_PLUS:CDE_MOTG = PWM[2][0]; CDE_MOTD = PWM[2][1];
_0x11D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x122
	LDD  R30,Y+10
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,11
	RCALL SUBOPT_0x2D
;     665         		if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	RCALL SUBOPT_0x2A
	BRNE _0x123
	RCALL SUBOPT_0x2B
;     666                              else if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
	RJMP _0x124
_0x123:
	RCALL SUBOPT_0x2F
	BRNE _0x125
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x222
;     667                         		else EtatCdeMot = CDE_DROITE_PLUS;
_0x125:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
_0x222:
	__PUTW1R 8,9
_0x124:
;     668         break;  
	RJMP _0x112
;     669         
;     670         case CDE_DROITE_2PLUS: CDE_MOTG = PWM[3][0]; CDE_MOTD = PWM[3][1];
_0x122:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x127
	LDD  R30,Y+12
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,13
	RCALL SUBOPT_0x2D
;     671         		if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
	RCALL SUBOPT_0x2E
	BRNE _0x128
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 8,9
;     672         	       		else if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
	RJMP _0x129
_0x128:
	RCALL SUBOPT_0x30
	BRNE _0x12A
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x223
;     673         				else EtatCdeMot = CDE_DROITE_2PLUS;
_0x12A:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
_0x223:
	__PUTW1R 8,9
_0x129:
;     674         break;
	RJMP _0x112
;     675              
;     676         case CDE_DROITE_3PLUS: CDE_MOTG = PWM[4][0]; CDE_MOTD = PWM[4][1];
_0x127:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x12C
	LDD  R30,Y+14
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x2D
;     677         		if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS; 
	RCALL SUBOPT_0x2F
	BRNE _0x12D
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 8,9
;     678         	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_DROITE;
	RJMP _0x12E
_0x12D:
	MOV  R0,R10
	OR   R0,R11
	BRNE _0x12F
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0x224
;     679         				else EtatCdeMot = CDE_DROITE_3PLUS;
_0x12F:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
_0x224:
	__PUTW1R 8,9
_0x12E:
;     680         break;
	RJMP _0x112
;     681         
;     682         case CDE_HORS_LIGNE_DROITE : CDE_MOTG = PWM[5][0]; CDE_MOTD = PWM[5][1];
_0x12C:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x131
	LDD  R30,Y+16
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,17
	RCALL SUBOPT_0x2D
;     683         		if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
	RCALL SUBOPT_0x30
	BRNE _0x132
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x225
;     684         				else EtatCdeMot = CDE_HORS_LIGNE_DROITE;
_0x132:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
_0x225:
	__PUTW1R 8,9
;     685         break;
	RJMP _0x112
;     686         			  			  
;     687         case CDE_GAUCHE: CDE_MOTG = PWM[6][0]; CDE_MOTD = PWM[6][1]; 
_0x131:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x134
	LDD  R30,Y+18
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,19
	RCALL SUBOPT_0x2D
;     688                        if (Position_Robot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
	RCALL SUBOPT_0x26
	BRNE _0x135
	RCALL SUBOPT_0x27
;     689                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	RJMP _0x136
_0x135:
	RCALL SUBOPT_0x31
	BRNE _0x137
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x226
;     690                           		else EtatCdeMot = CDE_GAUCHE;
_0x137:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
_0x226:
	__PUTW1R 8,9
_0x136:
;     691         break;  
	RJMP _0x112
;     692         
;     693         case CDE_GAUCHE_PLUS: CDE_MOTG = PWM[7][0]; CDE_MOTD = PWM[7][1]; 
_0x134:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x139
	LDD  R30,Y+20
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,21
	RCALL SUBOPT_0x2D
;     694                       if  (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RCALL SUBOPT_0x2C
	BRNE _0x13A
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	__PUTW1R 8,9
;     695         	              else if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
	RJMP _0x13B
_0x13A:
	RCALL SUBOPT_0x32
	BRNE _0x13C
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x227
;     696                                		else EtatCdeMot = CDE_GAUCHE_PLUS;
_0x13C:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
_0x227:
	__PUTW1R 8,9
_0x13B:
;     697         break; 
	RJMP _0x112
;     698         
;     699         case CDE_GAUCHE_2PLUS: CDE_MOTG = PWM[8][0]; CDE_MOTD = PWM[8][1];
_0x139:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x13E
	LDD  R30,Y+22
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,23
	RCALL SUBOPT_0x2D
;     700         		if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	RCALL SUBOPT_0x31
	BRNE _0x13F
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 8,9
;     701         		        else if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
	RJMP _0x140
_0x13F:
	RCALL SUBOPT_0x33
	BRNE _0x141
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RJMP _0x228
;     702         				else EtatCdeMot = CDE_GAUCHE_2PLUS;
_0x141:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
_0x228:
	__PUTW1R 8,9
_0x140:
;     703         break;
	RJMP _0x112
;     704         
;     705         case CDE_GAUCHE_3PLUS: CDE_MOTG = PWM[9][0]; CDE_MOTD = PWM[9][1];
_0x13E:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x143
	LDD  R30,Y+24
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,25
	RCALL SUBOPT_0x2D
;     706         		if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
	RCALL SUBOPT_0x32
	BRNE _0x144
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1R 8,9
;     707         	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_GAUCHE; 
	RJMP _0x145
_0x144:
	MOV  R0,R10
	OR   R0,R11
	BRNE _0x146
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0x229
;     708         				else EtatCdeMot = CDE_GAUCHE_3PLUS;
_0x146:
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
_0x229:
	__PUTW1R 8,9
_0x145:
;     709         break;
	RJMP _0x112
;     710         
;     711         case CDE_HORS_LIGNE_GAUCHE: CDE_MOTG = PWM[10][0]; CDE_MOTD = PWM[10][1];
_0x143:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x14B
	LDD  R30,Y+26
	RCALL SUBOPT_0x28
	MOVW R30,R28
	ADIW R30,27
	RCALL SUBOPT_0x2D
;     712         		if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
	RCALL SUBOPT_0x33
	BRNE _0x149
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RJMP _0x22A
;     713         				else EtatCdeMot = CDE_HORS_LIGNE_GAUCHE;
_0x149:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
_0x22A:
	__PUTW1R 8,9
;     714         break;
	RJMP _0x112
;     715         
;     716         default : EtatCdeMot = CDE_CENTRE; 
_0x14B:
	RCALL SUBOPT_0x27
;     717         break;
;     718          
;     719        }// Fin switch (EtatCdeMot)        
_0x112:
;     720 // ----------------------------------------------------------------------------------------  
;     721 // Fin Traiter 
;     722 
;     723        delay_us(704); //  ajuster   (704s  par dfaut) 		
	__DELAY_USW 1408
;     724     }
	RJMP _0xF7
;     725 } // fin Mode_Run();
	RCALL __LOADLOCR6
	ADIW R28,28
	RET
;     726 //*************************************************************************************************** 
;     727 
;     728 //***************************************************************************************************
;     729 // 			Arrt des moteurs 
;     730 //***************************************************************************************************
;     731 void Arret_Moteurs()
;     732 {
_Arret_Moteurs:
;     733       TCCR1A = 0x00; // Arrt PWM 
	CLR  R30
	OUT  0x2F,R30
;     734       TCCR1B = 0x00; 
	OUT  0x2E,R30
;     735       PORTD=0x00;     // Arrt Moteur 
	OUT  0x12,R30
;     736 } 
	RET
;     737 //*************************************************************************************************** 
;     738 
;     739 //***************************************************************************************************
;     740 // 			Activation des moteurs
;     741 //***************************************************************************************************
;     742 void Active_Timer()
;     743 {
_Active_Timer:
;     744       TCCR1A=0xA1;
	RCALL SUBOPT_0x1
;     745       TCCR1B=0x09;
;     746 } 
	RET
;     747 //***************************************************************************************************  
;     748 
;     749 //***************************************************************************************************  
;     750 // 			Squence de prise de la balle
;     751 //*************************************************************************************************** 
;     752 // Le robot est arrt dans le SP d'INT0
;     753 void Prise_Balle()
;     754 {
_Prise_Balle:
;     755 Cible = 0; // Dsactivation de la dtection de la cible
	CLT
	BLD  R2,0
;     756 
;     757 // Commande du bras (PB0 initialement en sortie et PB0=1)
;     758 // ========================================================
;     759 CDE_SERVO1 = 1; // Demande sortie du bras
	SBI  0x18,0
;     760 delay_ms(1000);
	RCALL SUBOPT_0x24
;     761 
;     762 // Commande de la main
;     763 //---------------------------------------------------------
;     764 CDE_SERVO2 = 1; // Activation Main
	SBI  0x18,1
;     765 delay_ms(1000);
	RCALL SUBOPT_0x24
;     766 
;     767 CDE_SERVO2 = 0; // Dsactivation Main (Economie nergie !)
	CBI  0x18,1
;     768 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x8
;     769 
;     770 CDE_SERVO1 = 0;  // Demande rentre du bras
	CBI  0x18,0
;     771 // =======================================================
;     772 
;     773 // Marche Robot
;     774 Active_Timer();  
	RCALL _Active_Timer
;     775 
;     776 }
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	RCALL SUBOPT_0x34
	SBIW R30,0
	BREQ _0x185
	RCALL SUBOPT_0x34
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x186
_0x185:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x186:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x188:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x18A
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x18E
	CPI  R19,37
	BRNE _0x18F
	LDI  R16,LOW(1)
	RJMP _0x190
_0x18F:
	RCALL SUBOPT_0x35
_0x190:
	RJMP _0x18D
_0x18E:
	CPI  R30,LOW(0x1)
	BRNE _0x191
	CPI  R19,37
	BRNE _0x192
	RCALL SUBOPT_0x35
	LDI  R16,LOW(0)
	RJMP _0x18D
_0x192:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x193
	LDI  R17,LOW(1)
	RJMP _0x18D
_0x193:
	CPI  R19,43
	BRNE _0x194
	LDI  R21,LOW(43)
	RJMP _0x18D
_0x194:
	CPI  R19,32
	BRNE _0x195
	LDI  R21,LOW(32)
	RJMP _0x18D
_0x195:
	RJMP _0x196
_0x191:
	CPI  R30,LOW(0x2)
	BRNE _0x197
_0x196:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x198
	ORI  R17,LOW(128)
	RJMP _0x18D
_0x198:
	RJMP _0x199
_0x197:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x18D
_0x199:
	CPI  R19,48
	BRLO _0x19C
	CPI  R19,58
	BRLO _0x19D
_0x19C:
	RJMP _0x19B
_0x19D:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x18D
_0x19B:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x1A1
	RCALL SUBOPT_0x36
	LD   R30,X
	RCALL SUBOPT_0x37
	RJMP _0x1A2
_0x1A1:
	CPI  R30,LOW(0x73)
	BRNE _0x1A4
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x38
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x1A5
_0x1A4:
	CPI  R30,LOW(0x70)
	BRNE _0x1A7
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x38
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x1A5:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x1A8
_0x1A7:
	CPI  R30,LOW(0x64)
	BREQ _0x1AB
	CPI  R30,LOW(0x69)
	BRNE _0x1AC
_0x1AB:
	ORI  R17,LOW(4)
	RJMP _0x1AD
_0x1AC:
	CPI  R30,LOW(0x75)
	BRNE _0x1AE
_0x1AD:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x1AF
_0x1AE:
	CPI  R30,LOW(0x58)
	BRNE _0x1B1
	ORI  R17,LOW(8)
	RJMP _0x1B2
_0x1B1:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x1E0
_0x1B2:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x1AF:
	SBRS R17,2
	RJMP _0x1B4
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x39
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x1B5
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x1B5:
	CPI  R21,0
	BREQ _0x1B6
	SUBI R16,-LOW(1)
	RJMP _0x1B7
_0x1B6:
	ANDI R17,LOW(251)
_0x1B7:
	RJMP _0x1B8
_0x1B4:
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x39
_0x1B8:
_0x1A8:
	SBRC R17,0
	RJMP _0x1B9
_0x1BA:
	CP   R16,R20
	BRSH _0x1BC
	SBRS R17,7
	RJMP _0x1BD
	SBRS R17,2
	RJMP _0x1BE
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x1BF
_0x1BE:
	LDI  R19,LOW(48)
_0x1BF:
	RJMP _0x1C0
_0x1BD:
	LDI  R19,LOW(32)
_0x1C0:
	RCALL SUBOPT_0x35
	SUBI R20,LOW(1)
	RJMP _0x1BA
_0x1BC:
_0x1B9:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1C1
_0x1C2:
	CPI  R18,0
	BREQ _0x1C4
	SBRS R17,3
	RJMP _0x1C5
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x22B
_0x1C5:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x22B:
	ST   -Y,R30
	RCALL SUBOPT_0x3A
	CPI  R20,0
	BREQ _0x1C7
	SUBI R20,LOW(1)
_0x1C7:
	SUBI R18,LOW(1)
	RJMP _0x1C2
_0x1C4:
	RJMP _0x1C8
_0x1C1:
_0x1CA:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1CC
	SBRS R17,3
	RJMP _0x1CD
	SUBI R19,-LOW(7)
	RJMP _0x1CE
_0x1CD:
	SUBI R19,-LOW(39)
_0x1CE:
_0x1CC:
	SBRC R17,4
	RJMP _0x1D0
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1D2
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1D1
_0x1D2:
	ORI  R17,LOW(16)
	RJMP _0x1D4
_0x1D1:
	CP   R20,R18
	BRLO _0x1D6
	SBRS R17,0
	RJMP _0x1D7
_0x1D6:
	RJMP _0x1D5
_0x1D7:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1D8
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1D4:
	SBRS R17,2
	RJMP _0x1D9
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x3A
	CPI  R20,0
	BREQ _0x1DA
	SUBI R20,LOW(1)
_0x1DA:
_0x1D9:
_0x1D8:
_0x1D0:
	RCALL SUBOPT_0x35
	CPI  R20,0
	BREQ _0x1DB
	SUBI R20,LOW(1)
_0x1DB:
_0x1D5:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1CB
	RJMP _0x1CA
_0x1CB:
_0x1C8:
	SBRS R17,0
	RJMP _0x1DC
_0x1DD:
	CPI  R20,0
	BREQ _0x1DF
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x37
	RJMP _0x1DD
_0x1DF:
_0x1DC:
_0x1E0:
_0x1A2:
	LDI  R16,LOW(0)
_0x18D:
	RJMP _0x188
_0x18A:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x3B
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x3B
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x6
	RCALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x213
_fmod:
	SBIW R28,4
	__GETD1S 4
	RCALL __CPD10
	BRNE _0x1E3
	__GETD1N 0x0
	RJMP _0x214
_0x1E3:
	__GETD1S 4
	__GETD2S 8
	RCALL __DIVF21
	__PUTD1S 0
	RCALL __CPD10
	BRNE _0x1E4
	__GETD1N 0x0
	RJMP _0x214
_0x1E4:
	__GETD2S 0
	RCALL __CPD02
	BRGE _0x1E5
	RCALL SUBOPT_0x3C
	RCALL _floor
	RJMP _0x22C
_0x1E5:
	RCALL SUBOPT_0x3C
	RCALL _ceil
_0x22C:
	__PUTD1S 0
	__GETD2S 4
	RCALL __MULF12
	__GETD2S 8
	RCALL __SWAPD12
	RCALL __SUBF12
_0x214:
	ADIW R28,12
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x3D
_0x213:
	ADIW R28,4
	RET
_Lire_BP_Robot:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x3E
	MOV  R17,R30
	SBIS 0x10,7
	RJMP _0x1F4
	SUBI R17,-LOW(8)
_0x1F4:
	__GETW1R 12,13
	SBIW R30,0
	BRNE _0x1F8
	CPI  R17,0
	BRNE _0x1F9
	MOV  R16,R17
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x3E
	SBIS 0x10,7
	RJMP _0x1FA
	SUBI R17,-LOW(8)
_0x1FA:
	CP   R17,R16
	BRNE _0x1FB
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
	LDI  R30,LOW(255)
	RJMP _0x212
_0x1FB:
	CLR  R30
	RJMP _0x212
	RJMP _0x1FD
_0x1F9:
	CLR  R30
	RJMP _0x212
_0x1FD:
	RJMP _0x1F7
_0x1F8:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1F7
	CPI  R17,0
	BREQ _0x1FF
	MOV  R16,R17
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x3E
	MOV  R17,R30
	SBIS 0x10,7
	RJMP _0x200
	SUBI R17,-LOW(8)
_0x200:
	CP   R17,R16
	BRNE _0x201
	CLR  R12
	CLR  R13
	MOV  R30,R17
	RJMP _0x212
_0x201:
	LDI  R30,LOW(255)
	RJMP _0x212
	RJMP _0x203
_0x1FF:
	LDI  R30,LOW(255)
_0x203:
_0x1F7:
_0x212:
	RCALL __LOADLOCR2P
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G8:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	RCALL __lcd_ready
	LDD  R30,Y+1
	RCALL SUBOPT_0x40
	RCALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x40
	ADIW R28,2
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G8:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G8)
	SBCI R31,HIGH(-__base_y_G8)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x40
	LDD  R14,Y+1
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x40
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x40
	RCALL __lcd_ready
	RCALL SUBOPT_0x1E
	RCALL __lcd_write_data
	CLR  R30
	STS  __lcd_y,R30
	MOV  R14,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R14
	LDS  R30,__lcd_maxx
	CP   R30,R14
	BRSH _0x20B
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x1C
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x20B:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G8:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G8:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G8,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G8,3
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x41
	RCALL __long_delay_G8
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G8
	RCALL __long_delay_G8
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x40
	RCALL __long_delay_G8
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x40
	RCALL __long_delay_G8
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x40
	RCALL __long_delay_G8
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G8
	CPI  R30,LOW(0x5)
	BREQ _0x210
	CLR  R30
	RJMP _0x211
_0x210:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x40
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x211:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(255)
	OUT  0x1B,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(161)
	OUT  0x2F,R30
	LDI  R30,LOW(9)
	OUT  0x2E,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2:
	MOV  R30,R17
	CLR  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	ST   -Y,R30
	RJMP _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES
SUBOPT_0x4:
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x5:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES
SUBOPT_0x6:
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x7:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	CLR  R30
	ST   -Y,R30
	RCALL _lcd_putchar
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xA:
	MOV  R30,R16
	CPI  R30,LOW(0x8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xB:
	LDD  R30,Y+39
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTPARD1
	__GETD1N 0x40000000
	RCALL __PUTPARD1
	RCALL _fmod
	RCALL __CPD10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xC:
	LDD  R30,Y+41
	LSR  R30
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	MOVW R26,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	RCALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xF:
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x10:
	LDD  R30,Y+39
	LSR  R30
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	CLR  R31
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	ADD  R26,R30
	ADC  R27,R31
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x12:
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	RCALL _itoa
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	RCALL _strcat
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LSR  R30
	SUBI R30,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	CLR  R31
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDI  R30,LOW(14)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	CLR  R30
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(37)
	ST   -Y,R30
	RCALL _lcd_putchar
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1C:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	LDI  R26,LOW(_Table_Calcul_OCR1x*2)
	LDI  R27,HIGH(_Table_Calcul_OCR1x*2)
	MOV  R30,R18
	CLR  R31
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x26:
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x27:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 8,9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x28:
	CLR  R31
	OUT  0x28+1,R31
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x29:
	CLR  R31
	OUT  0x2A+1,R31
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2B:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 8,9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x2D:
	LD   R30,Z
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x35:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x36:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x38:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x39:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3A:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3C:
	__GETD1S 0
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3D:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3E:
	IN   R30,0x16
	ANDI R30,LOW(0xE0)
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3F:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x40:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x41:
	RCALL __long_delay_G8
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G8

_itoa:
	ld   r26,y+
	ld   r27,y+
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	brpl __itoa0
	com  r30
	com  r31
	adiw r30,1
	ldi  r22,'-'
	st   x+,r22
__itoa0:
	clt
	ldi  r24,low(10000)
	ldi  r25,high(10000)
	rcall __itoa1
	ldi  r24,low(1000)
	ldi  r25,high(1000)
	rcall __itoa1
	ldi  r24,100
	clr  r25
	rcall __itoa1
	ldi  r24,10
	rcall __itoa1
	mov  r22,r30
	rcall __itoa5
	clr  r22
	st   x,r22
	ret
__itoa1:
	clr	 r22
__itoa2:
	cp   r30,r24
	cpc  r31,r25
	brlo __itoa3
	inc  r22
	sub  r30,r24
	sbc  r31,r25
	brne __itoa2
__itoa3:
	tst  r22
	brne __itoa4
	brts __itoa5
	ret
__itoa4:
	set
__itoa5:
	subi r22,-0x30
	st   x+,r22
	ret

_strcat:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcat0:
	ld   r22,x+
	tst  r22
	brne __strcat0
	sbiw r26,1
__strcat1:
	ld   r22,z+
	st   x+,r22
	tst  r22
	brne __strcat1
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD1:
	CLR  R31
	CLR  R22
	CLR  R23
	SBRS R30,7
	RET
	SER  R31
	SER  R22
	SER  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

