
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float ftrunc(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#pragma used+

unsigned char Lire_BP(void);

void Affiche_LCD(char *ligne1,char *ligne2);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);

void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);

void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);

int regle_HTR(unsigned char adresse,unsigned char Heure_ou_Date, char H_J, char mn_mois, int sec_annee);

unsigned char D2000read(unsigned char adreemap);

void D2000_write(unsigned char adressmap, unsigned char data);

int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);

unsigned char Menu_Select_Seringue(void);

#pragma used-

#pragma library ssi.lib

#pragma used+

unsigned char Lire_BP_Robot(void);

#pragma used-

#pragma library LibRobot.lib

#asm
   .equ __lcd_port=0x15
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

eeprom unsigned char PWM_EEPROM[11][2];  	

const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    
const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     

flash struct Affichage_reglages {
char ligne0[14];
char ligne1[14];  
} Tab_Aff_Reg[11]= {{"Centre MG  =","Centre MD  ="},
{"Droite MG  =","Droite MD  ="},
{"Droite+ MG =","Droite+ MD ="},
{"Droite2+ MG=","Droite2+ MD="},
{"Droite3+ MG=","Droite3+ MD="},
{"HorLigD MG =","HorLigD MD ="},
{"Gauche MG  =","Gauche MD  ="},
{"Gauche+ MG =","Gauche+ MD ="},
{"Gauche2+ MG=","Gauche2+ MD="},
{"Gauche3+ MG=","Gauche3+ MD="},
{"HorLigG MG =","HorLigG MD ="}};

const unsigned char Table_Calcul_OCR1x[19][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
{35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
{90,233}}; 		

void Arret_Moteurs(void);	
void Active_Timer(void);    	
void Mode_Run(void);        	
void Prise_Balle(void);		

enum TMenu {Menu_Reglages, Menu_Servo, Menu_Run, Reglage_PWM, Activation, Affiche_Reglages,Cde_Servo
} Menu=Menu_Reglages,Menu_1=Menu_Run;

enum Etat_Commande_Moteur {DEPART,CDE_CENTRE, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, 
CDE_DROITE_2PLUS, CDE_DROITE_3PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS,CDE_GAUCHE_2PLUS,CDE_GAUCHE_3PLUS,
CDE_HORS_LIGNE_GAUCHE, CDE_HORS_LIGNE_DROITE } EtatCdeMot = DEPART;

enum Etat_Position_Robot {HORS_LIGNE, GAUCHE_3PLUS, GAUCHE_2PLUS = 3, CENTRE_1, GAUCHE_PLUS=7, 
CENTRE_3=14, GAUCHE, DROITE_3PLUS, DROITE_2PLUS=24, DROITE_PLUS=28, DROITE = 30,CENTRE_5} 
Position_Robot = HORS_LIGNE; 

bit Cible=0;

interrupt [2] void ext_int0_isr(void)
{

GICR=0x00; 
Arret_Moteurs();  
Cible = 1;
}  

void main(void)
{ 

unsigned char BP;			
unsigned char i;                        
unsigned char rcycl, rcycl_1;           
unsigned char NumServo=1, NumServo_1=1;	
unsigned char decompte=5, decompte_1=5;	
char i_n=0, i_n_1=1;			

char display_buffer_ligne0[17]; 	
char display_buffer_ligne1[17]; 	
char pourcentage0[2], pourcentage1[2];  

PORTA=0xFF; 	
DDRA=0xFF;	

PORTB=0x10;     
DDRB=0x13;      

PORTC=0x00; 
DDRC=0x00;    

PORTD=0x04;     
DDRD=0x30; 	

TCCR1A=0xA1;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

ACSR=0x00;
SFIOR=0x00;

lcd_init(16);

for (i=0;i<8;i++)
{
lcd_write_byte(0x40  + i, flecheHaut[i]); 
lcd_write_byte(0x48  + i, flecheBas[i]); 
}

PORTB.0 = 0;
PORTB.1 = 0;

lcd_clear();
sprintf(display_buffer_ligne0,"******RBOT******");
sprintf(display_buffer_ligne1,"---PEM BOURGES--");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
delay_ms(3000);

while (1)
{    
BP = Lire_BP_Robot();

switch (Menu)
{

case Menu_Reglages : if (Menu_1 != Menu)
{
sprintf(display_buffer_ligne0," Menu Reglages ");
sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
lcd_gotoxy(11,1);	
lcd_putchar(0 );	
lcd_gotoxy(10,1);	
lcd_putchar(1);
}

switch(BP)
{                                  
case 8  : Menu = Affiche_Reglages;  break; 
case 2   : Menu = Menu_Run;  break; 
case 1    : Menu = Menu_Servo;  break; 
default: Menu = Menu_Reglages;
}

Menu_1 = Menu_Reglages;
break;  

case Menu_Servo : if (Menu_1 != Menu)
{
sprintf(display_buffer_ligne0,"--Test Servos?--");
sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
lcd_gotoxy(11,1);	
lcd_putchar(0 );	
lcd_gotoxy(10,1);	
lcd_putchar(1);
}

switch(BP)
{                                  
case 8  : Menu = Cde_Servo;  break; 
case 2   : Menu = Menu_Reglages;  break; 
case 1    : Menu = Menu_Run;  break; 
default: Menu = Menu_Servo;
}

Menu_1 = Menu_Servo;
break; 
case Menu_Run : if (Menu_1 != Menu)
{
sprintf(display_buffer_ligne0,"Activer robot ? ");
sprintf(display_buffer_ligne1,"[Etr]>Oui   suiv");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
lcd_gotoxy(11,1);	
lcd_putchar(0 );	
lcd_gotoxy(10,1);	
lcd_putchar(1);
}

switch(BP)
{                                  
case 8  : Menu = Activation; break; 
case 2   : Menu = Menu_Servo; break; 
case 1    : Menu = Menu_Reglages; break; 
default: Menu = Menu_Run;
}

Menu_1 = Menu_Run;
break;   

case Affiche_Reglages : if ((Menu_1 != Menu) || (i_n_1 != i_n))
{
if (fmod(i_n,2)==0){ 
sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
strcat(display_buffer_ligne0,pourcentage0);
sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1);
itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
strcat(display_buffer_ligne1,pourcentage1);
}
else { 
sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
strcat(display_buffer_ligne0,pourcentage0);
sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2+1].ligne0);
itoa(PWM_EEPROM[i_n/2+1][0],pourcentage1);
strcat(display_buffer_ligne1,pourcentage1);
}
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
lcd_gotoxy(14,0);
lcd_putchar('%');
lcd_gotoxy(15,0);	
lcd_putchar(0 );
lcd_gotoxy(14,1);
lcd_putchar('%');	
lcd_gotoxy(15,1);	
lcd_putchar(1);
i_n_1 = i_n;
}

switch(BP)
{                                  
case 8  :  if (fmod(i_n,2)==0) 
rcycl = PWM_EEPROM[i_n/2][0];
else     
rcycl = PWM_EEPROM[i_n/2][1];

Menu = Reglage_PWM;  
break;  
case 4: Menu = Menu_Reglages; break;
case 1    : if (i_n < 21) i_n++; else i_n=0; break; 
case 2   : if (i_n > 0) i_n--; else i_n=21; break; 
default: Menu = Affiche_Reglages;
}

Menu_1 = Affiche_Reglages;
break;   

case Reglage_PWM : if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
{ 
if (fmod(i_n,2)==0){ 
sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
itoa(rcycl,pourcentage0);
strcat(display_buffer_ligne0,pourcentage0);}
else{
sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
itoa(rcycl,pourcentage0);
strcat(display_buffer_ligne0,pourcentage0);}
sprintf(display_buffer_ligne1,"Etr>Memo ECH>Q ");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
lcd_gotoxy(15,0);
lcd_putchar('+');
lcd_gotoxy(15,1);
lcd_putchar('-');
rcycl_1 = rcycl;
}

switch(BP)
{
case 8  : if (fmod(i_n,2)==0) 
PWM_EEPROM[i_n/2][0]=rcycl;
else     
PWM_EEPROM[i_n/2][1]=rcycl; 
Menu = Affiche_Reglages;     
break;                                  
case 4: Menu = Affiche_Reglages;  break; 
case 2   : if (rcycl < 95) rcycl = rcycl+5; else rcycl = 95; break; 
case 1    : if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; 
default: Menu = Reglage_PWM;
}

Menu_1 = Reglage_PWM;
break;   

case Activation : if ((Menu_1 != Menu) || (decompte != decompte_1))
{
sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
decompte_1 = decompte;
}

if (BP==4) {
decompte=8;
Menu=Menu_Reglages;
break;
}
else if(decompte == 0) 
Mode_Run();
delay_ms(1000); decompte--;
Menu_1 = Activation;
break; 

case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1))
{
sprintf(display_buffer_ligne0,"Commande Servo%-u ",NumServo);
sprintf(display_buffer_ligne1,"[Etr]>Ch [Ech]>Q");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
NumServo_1 = NumServo;
}

switch(BP)
{                                  
case 8  : if (NumServo==2) NumServo=1;
else if (NumServo==1) NumServo=2;		
break;  
case 4: Menu = Menu_Servo; break;
case 2   : if (NumServo==1) {PORTB.0=1; PORTA.5 	 = 0;}
else if  (NumServo==2) {PORTB.1=1; PORTA.6 	 = 0;}   
break;
case 1    : if (NumServo==1) {PORTB.0=0;PORTA.5 	 = 1;}
else if  (NumServo==2) {PORTB.1=0; PORTA.6 	 = 1;}
break; 
default: Menu = Cde_Servo;
}
Menu_1 = Cde_Servo;
break;           

} 
} 
} 

void Mode_Run()
{

unsigned char i,j,k;            
unsigned char PWM[11][2];	

unsigned char Cde_Del_IR;	
unsigned int Phase_Arret = 50;	

for (i=0;i<11;i++)
{ 
for (j=0;j<2;j++)
{ 
for (k=0;k<19;k++)
{
if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
{   
PWM[i][j] = Table_Calcul_OCR1x[k][1];
break;
}
}
}
} 

#asm("sei") 

while (1)
{

if (Cible == 1) 
{
if (Phase_Arret == 0)
Prise_Balle(); 
else 
Phase_Arret--;
}

Position_Robot = HORS_LIGNE; 
Cde_Del_IR = 1; 

for (i=0;i<5;i++)  
{
PORTA      = ~Cde_Del_IR;
delay_us(20);	
if (ACSR.5       == 1) Position_Robot = Position_Robot | Cde_Del_IR;
PORTA      = 0xFF; PORTB.4 	 = 1;
Cde_Del_IR = Cde_Del_IR << 1 ;
delay_us(700);	
} 

switch (Position_Robot)              
{ 

case 0:  PORTB.4 	=1; PORTA.7 	=1; PORTA.6 	=1; PORTA.5 	=1; break;
case 1:  PORTB.4 	=1; PORTA.7 	=1; PORTA.6 	=1; PORTA.5 	=0; break;
case 3:  PORTB.4 	=1; PORTA.7 	=1; PORTA.6 	=0; PORTA.5 	=0; break;
case 4:  PORTB.4 	=1; PORTA.7 	=1; PORTA.6 	=1; PORTA.5 	=1; break;
case 7:  PORTB.4 	=1; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=0; break;
case 14: PORTB.4 	=1; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=1; break;
case 15: PORTB.4 	=1; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=0; break;
case 16: PORTB.4 	=0; PORTA.7 	=1; PORTA.6 	=1; PORTA.5 	=1; break;
case 24: PORTB.4 	=0; PORTA.7 	=0; PORTA.6 	=1; PORTA.5 	=1; break;
case 28: PORTB.4 	=0; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=1; break;
case 30: PORTB.4 	=0; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=1; break;
case 31: PORTB.4 	=0; PORTA.7 	=0; PORTA.6 	=0; PORTA.5 	=0; break;
}   

switch (EtatCdeMot)              
{ 
case DEPART: Arret_Moteurs(); 
if ((Position_Robot == CENTRE_3)||(Position_Robot == CENTRE_5))
{ 

Active_Timer();
EtatCdeMot = CDE_CENTRE;
}
else  EtatCdeMot = DEPART;
break;   

case CDE_CENTRE : OCR1B	     = PWM[0][0]; OCR1A        = PWM[0][1];
if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
else EtatCdeMot = CDE_CENTRE;
break;  

case CDE_DROITE:OCR1B	     = PWM[1][0]; OCR1A        = PWM[1][1]; 
if (Position_Robot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
else EtatCdeMot = CDE_DROITE;
break;   

case CDE_DROITE_PLUS:OCR1B	     = PWM[2][0]; OCR1A        = PWM[2][1];
if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
else if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
else EtatCdeMot = CDE_DROITE_PLUS;
break;  

case CDE_DROITE_2PLUS: OCR1B	     = PWM[3][0]; OCR1A        = PWM[3][1];
if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
else if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
else EtatCdeMot = CDE_DROITE_2PLUS;
break;

case CDE_DROITE_3PLUS: OCR1B	     = PWM[4][0]; OCR1A        = PWM[4][1];
if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS; 
else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_DROITE;
else EtatCdeMot = CDE_DROITE_3PLUS;
break;

case CDE_HORS_LIGNE_DROITE : OCR1B	     = PWM[5][0]; OCR1A        = PWM[5][1];
if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
else EtatCdeMot = CDE_HORS_LIGNE_DROITE;
break;

case CDE_GAUCHE: OCR1B	     = PWM[6][0]; OCR1A        = PWM[6][1]; 
if (Position_Robot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
else EtatCdeMot = CDE_GAUCHE;
break;  

case CDE_GAUCHE_PLUS: OCR1B	     = PWM[7][0]; OCR1A        = PWM[7][1]; 
if  (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
else if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
else EtatCdeMot = CDE_GAUCHE_PLUS;
break; 

case CDE_GAUCHE_2PLUS: OCR1B	     = PWM[8][0]; OCR1A        = PWM[8][1];
if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
else if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
else EtatCdeMot = CDE_GAUCHE_2PLUS;
break;

case CDE_GAUCHE_3PLUS: OCR1B	     = PWM[9][0]; OCR1A        = PWM[9][1];
if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_GAUCHE; 
else EtatCdeMot = CDE_GAUCHE_3PLUS;
break;

case CDE_HORS_LIGNE_GAUCHE: OCR1B	     = PWM[10][0]; OCR1A        = PWM[10][1];
if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
else EtatCdeMot = CDE_HORS_LIGNE_GAUCHE;
break;

default : EtatCdeMot = CDE_CENTRE; 
break;

}

delay_us(704); 
}
} 

void Arret_Moteurs()
{
TCCR1A = 0x00; 
TCCR1B = 0x00; 
PORTD=0x00;     
} 

void Active_Timer()
{
TCCR1A=0xA1;
TCCR1B=0x09;
} 

void Prise_Balle()
{
Cible = 0; 

PORTB.0 = 1; 
delay_ms(1000);

PORTB.1 = 1; 
delay_ms(1000);

PORTB.1 = 0; 
delay_ms(10);

PORTB.0 = 0;  

Active_Timer();  

}
